<?xml version="1.0" encoding="UTF-8"?>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                              xmlns:xh="http://www.w3.org/1999/xhtml">

<xsl:output omit-xml-declaration="no" version="1.0" method="xml" indent="no" encoding="UTF-8"/>

<xsl:param name="spacer" select="'  '"/>



<xsl:template match="*[ancestor::*[./@xml:space][1]/@xml:space = 'preserve']
                     | *[ancestor::xh:pre]" priority="15">
    <xsl:element name="{local-name()}" namespace="{namespace-uri(.)}">
        <xsl:copy-of select="@*"/>
        <xsl:apply-templates/>
    </xsl:element>
</xsl:template>

<xsl:template match="*[./@xml:space = 'preserve']
                     | xh:pre" priority="14">
    <xsl:call-template name="space"/>
    <xsl:element name="{local-name()}" namespace="{namespace-uri(.)}">
        <xsl:copy-of select="@*"/>
        <xsl:apply-templates/>
    </xsl:element>
    <xsl:text>
</xsl:text>
</xsl:template>

<xsl:template match="*[following-sibling::text() or preceding-sibling::text() or ancestor::*[following-sibling::text() or preceding-sibling::text()]]" priority="13">
    <xsl:element name="{local-name()}" namespace="{namespace-uri(.)}">
        <xsl:copy-of select="@*"/>
        <xsl:apply-templates/>
    </xsl:element>
</xsl:template>

<xsl:template match="*[not(child::node())]" priority="12">
    <xsl:call-template name="space"/>
    <xsl:element name="{local-name()}" namespace="{namespace-uri(.)}">
        <xsl:copy-of select="@*"/>
        <xsl:apply-templates/>
    </xsl:element>
    <xsl:text>
</xsl:text>
</xsl:template>

<xsl:template match="*[child::text()]" priority="11">
    <xsl:call-template name="space"/>
    <xsl:element name="{local-name()}" namespace="{namespace-uri(.)}">
        <xsl:copy-of select="@*"/>
        <xsl:apply-templates/>
    </xsl:element>
    <xsl:text>
</xsl:text>
</xsl:template>

<xsl:template match="*[not(child::text())]" priority="10">
    <xsl:call-template name="space"/>
    <xsl:element name="{local-name()}" namespace="{namespace-uri(.)}">
        <xsl:copy-of select="@*"/><xsl:text>
</xsl:text>
        <xsl:apply-templates/>
        <xsl:call-template name="space"/>
    </xsl:element>
    <xsl:text>
</xsl:text>
</xsl:template>


<xsl:template match="comment()[ancestor::comment()[./@xml:space][1]/@xml:space = 'preserve']
                     | comment()[ancestor::xh:pre]" priority="7">
    <xsl:copy-of select="."/>
</xsl:template>

<xsl:template match="comment()[following-sibling::text() or preceding-sibling::text() or ancestor::*[following-sibling::text() or preceding-sibling::text()]]" priority="6">
    <xsl:copy-of select="."/>
</xsl:template>

<xsl:template match="comment()" priority="5">
    <xsl:call-template name="space"/>
    <xsl:copy-of select="."/>
    <xsl:text>
</xsl:text>
</xsl:template>


<xsl:template name="space">
    <xsl:for-each select="ancestor::*">
        <xsl:value-of select="$spacer"/>
    </xsl:for-each>
</xsl:template>

</xsl:stylesheet>